package no.malmanger.seraph;

import org.apache.log4j.Logger;
import org.apache.log4j.Level;
import java.io.IOException;
import java.io.InputStream;
import java.io.FileInputStream;
import java.util.List;
import java.util.Properties;

public class RemoteUserConfigLoader {
	
	private static final Logger log = Logger.getLogger(RemoteUserConfigLoader.class);
	
	public static RemoteUserConfiguration getRemoteUserConfiguration(RemoteUserConfiguration oldConfig) {
//		log.setLevel(Level.DEBUG);
		
		if (log.isDebugEnabled()) {
			log.debug("RemoteUserAuthenticator using property resource " + RemoteUserConfiguration.PROPERTIES_FILE);
		}

		log.debug("RemoteUserAuthenticator using property resource " + RemoteUserConfiguration.PROPERTIES_FILE);

		RemoteUserConfiguration config = new RemoteUserConfiguration();

		log.debug("RemoteUserAuthenticator config is new ");
		
		try {
			InputStream propsIn = null;
			
			log.debug("RemoteUserAuthenticator.class.getResourceAsStream");
			propsIn = RemoteUserAuthenticator.class.getResourceAsStream(RemoteUserConfiguration.PROPERTIES_FILE);
			
			log.debug("configProps.load");
			Properties configProps = new Properties();
			configProps.load(propsIn);
			
			log.debug("config.setCreateUsers=" + Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.CREATE_USERS)).booleanValue());
            config.setCreateUsers(Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.CREATE_USERS)).booleanValue());
            if (log.isDebugEnabled()) { log.debug("Setting create new users to " + config.isCreateUsers()); }

			log.debug("config.setRemoteUserHeaderName=" + configProps.getProperty(  RemoteUserConfiguration.REMOTE_USER_HEADER_NAME_PROPERTY));
            config.setRemoteUserHeaderName(configProps.getProperty(  RemoteUserConfiguration.REMOTE_USER_HEADER_NAME_PROPERTY));
            if (log.isDebugEnabled()) { log.debug("HTTP Header that may contain user's username set to: " + config.getRemoteUserHeaderName()); }
			
			log.debug("config.setFullNameHeaderName=" + configProps.getProperty( RemoteUserConfiguration.FULLNAME_HEADER_NAME_PROPERTY));
			config.setFullNameHeaderName(configProps.getProperty( RemoteUserConfiguration.FULLNAME_HEADER_NAME_PROPERTY));
			if (log.isDebugEnabled()) { log.debug("HTTP Header that may contain user's full name set to: " + config.getFullNameHeaderName()); }
			
			log.warn("config.setEmailHeaderName=" + configProps.getProperty( RemoteUserConfiguration.EMAIL_HEADER_NAME_PROPERTY));
			config.setEmailHeaderName(configProps.getProperty( RemoteUserConfiguration.EMAIL_HEADER_NAME_PROPERTY));
			if (log.isDebugEnabled()) { log.debug("HTTP Header that may contain user's email address set to: " + config.getEmailHeaderName()); }

			log.warn("config.setDefaultGroups=" + configProps.getProperty( RemoteUserConfiguration.DEFAULT_GROUPS));
			config.setDefaultGroups(configProps.getProperty(RemoteUserConfiguration.DEFAULT_GROUPS));
			if (log.isDebugEnabled()) { log.debug("Default groups to add new users into: " + config.getDefaultGroups().toString()); }
			
			log.debug("config.setUpdateInfo=" + Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.UPDATE_INFO)).booleanValue());
            config.setUpdateInfo(Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.UPDATE_INFO)).booleanValue());
            if (log.isDebugEnabled()) { log.debug("Setting create new users to " + config.isUpdateInfo()); }

			log.debug("config.setUpdateGroups=" + Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.UPDATE_GROUPS)).booleanValue());
            config.setUpdateGroups(Boolean.valueOf(configProps.getProperty(RemoteUserConfiguration.UPDATE_GROUPS)).booleanValue());
            if (log.isDebugEnabled()) { log.debug("Setting create new users to " + config.isUpdateGroups()); }

		} catch (IOException e) {
			log.warn("Unable to read properties file, using default properties", e);
		}

log.debug("remoteUserHeaderName:" + config.getRemoteUserHeaderName());		
		return config;
	}
	
}
